#include ".\fitnessfunctionHW.h"

HWfitnessfunction::HWfitnessfunction() //constructor 
{
	this->Minimize = true; //por defeito inicializa com true
	this->particleCompare = HWparticle_compare_minimize; // default : to minimize
}


void HWfitnessfunction::HWSetMinimize(bool MinimizeFlag)
{
	if (MinimizeFlag == false)
	{
		this->particleCompare = HWparticle_compare_maximize;
		this->Minimize = false;
	}
	else 
	{
		this->particleCompare = HWparticle_compare_minimize;
		this->Minimize = true;
	}
}



bool HWfitnessfunction::HWfitnessCompare(double fit1, double fit2)
{

	if (Minimize)
	{
		if (fit1 < fit2) // minimizing
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	else 
	{
		if (fit1 > fit2) // maximizing
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}



bool HWparticle_compare_minimize(HWparticle &Particle1, HWparticle &Particle2) // predicate function for comparison in sort algorithm
{
	if (Particle1.HWGetFitness() < Particle2.HWGetFitness()) 
	{
		return true;
	}
	else
	{
		return false;
	}
}


bool HWparticle_compare_maximize(HWparticle &Particle1, HWparticle &Particle2) // predicate function for comparison in sort algorithm
{
	if (Particle1.HWGetFitness() > Particle2.HWGetFitness()) 
	{
		return true;
	}
	else
	{
		return false;
	}
}

