//=================================
// include guard
#pragma once

//=================================
enum GLOBAL_Train 
{
	ITL,
	PROP,
	PCA_train
};

//=================================
//Activation Functions
enum ActivationFunctions 
{
	NEURON_ACT_LOGISTIC,
	NEURON_ACT_TANH,
	NEURON_ACT_LINEAR
};

//=================================
enum sigmaOption 
{
	SILVERMAN_RULE,
	PRINCIPE_RULE
};

//=================================
enum OjaRule 
{
	OjaYES,
	OjaNO
};

//=================================
enum TrainMethods_W1 
{
	ENTROPY,
	CAUCHY_SCHWARTZ,
	EUCLIDEAN_DISTANCE,
	UNI
};

//=================================
enum TrainMethods_W2 
{
	W2_PROP,
	CIM,
	Corr
};

//=================================
enum InitializationW1Methods 
{
	RANDOM_W1,
	PCA
};

//=================================
enum InitializationW2Methods 
{
	RANDOM_W2,
	TRANSPOSE
};

//=================================
enum InitializationB1Methods 
{
	RANDOM_B1,
	ZEROS_B1
};

//=================================
enum InitializationB2Methods 
{
	RANDOM_B2,
	ZEROS_B2
};

//=================================
enum NormalizationMethod
{
	ENTRANCE_MIN_MAX,
	GLOBAL_MIN_MAX,
	ENTRANCE_ZSCORE,
	GLOBAL_ZSCORE,
	NONE
};

//=================================
enum ProblemSelection
{
	Reservoirs8,
	Reservoirs12
};

//=================================
enum Initi_Vel
{
	RANDOM_VEL,
	TRANSFER_VEL
};
